-- ************************************************************************** --
-- * TitanSpec.lua                                                          * --
-- *                                                                        * --
-- * By: Rothpada                                                           * --
-- ************************************************************************** --

local TITAN_SPEC_ID = "TitanSpec";
local AceTimer = LibStub("AceTimer-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("TitanSpec", true)

local TitanSpec_IS_DEBUGGING = false;

-- ************************************************************************** --
-- ******************************** Titan Functions ************************* --
-- ************************************************************************** --

function TitanPanelTitanSpecButton_OnLoad(self)
     self.registry = {
          id = TITAN_SPEC_ID,
          menuText = L["TITAN_SPEC_MENU_TEXT"],
          buttonTextFunction = "TitanPanelTitanSpecButton_GetButtonText",
          tooltipTitle = L["TITAN_SPEC_TOOLTIP_TITLE"],
          tooltipTextFunction = "TitanPanelTitanSpecButton_GetTooltipText",
	      frequency = 1.0,
          savedVariables = {
               ShowLabelText = 1,
          }
     };

	AceTimer.ScheduleRepeatingTimer("TitanPanel"..TITAN_SPEC_ID, TitanPanelPluginHandle_OnUpdate, 1, {TITAN_SPEC_ID, TITAN_PANEL_UPDATE_BUTTON })
	TitanSpec_output(TITAN_SPEC_ID.." by Rothpada (Shadow Council)");
	TitanPanelPluginHandle_OnUpdate({TITAN_SPEC_ID, TITAN_PANEL_UPDATE_ALL})
end

function TitanPanelTitanSpecButton_OnClick(self)
	if ( GetNumTalentGroups() > 1 ) then
		-- switch specs
		SetActiveTalentGroup(mod(GetActiveTalentGroup(), GetNumTalentGroups()) + 1);
	end
	
	TitanPanelPluginHandle_OnUpdate({TITAN_SPEC_ID, TITAN_PANEL_UPDATE_ALL})
end

function TitanPanelTitanSpecButton_OnEvent(self, event, ...)
	TitanSpec_debug(event);
	TitanPanelPluginHandle_OnUpdate({TITAN_SPEC_ID, TITAN_PANEL_UPDATE_ALL})
end

function TitanPanelTitanSpecButton_GetButtonText(id)
    local msg = "";
	local label = L["TITAN_SPEC_SPEC"].." "..GetActiveTalentGroup()..": ";

    -- Build the button text
	local b1,_,t1,_ = GetTalentTabInfo(1, false, false);
	local b2,_,t2,_ = GetTalentTabInfo(2, false, false);
	local b3,_,t3,_ = GetTalentTabInfo(3, false, false);
	
	local buildName = L["TITAN_SPEC_HYBRID"];

	if ( t1 > 40 ) then
		buildName = b1;
	elseif ( t2 > 40 ) then
		buildName = b2;
	elseif ( t3 > 40 ) then
		buildName = b3;
	end

    return label, format("%s (%d/%d/%d)", buildName, t1, t2, t3);
end

function TitanPanelTitanSpecButton_GetTooltipText(self)
	local tooltip = "";

	return tooltip;
end

function TitanPanelRightClickMenu_PrepareTitanSpecMenu()

end

-- ************************************************************************** --
-- ******************************** User Functions ************************** --
-- ************************************************************************** --

function TitanSpec_debug(msg)
	if TitanSpec_IS_DEBUGGING then
		TitanSpec_output(msg);
	end
end

function TitanSpec_output(msg)
    DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 1);
end

